<?php
/*
  Plugin Name: Social Media Widget
  Description: Adds a widget with links to all of your social media profiles.
  Version: 10.0
*/


define('SMW_PLUGINPATH',plugins_url());
define('SMW_PLUGINDIR',dirname(__FILE__));

function Social_Widget_Scripts(){	
	$social_widget_path = SMW_PLUGINPATH; 
} 

function socialwidget_load_widgets() {
	register_widget( 'Social_Widget' );
}

global $socials;
$socials = array(
	'facebook',
	'google-plus',
	'twitter',
	'linkedin',
	'foursquare',
	'weibo',
	'renren',
	'vk',
	'behance',
	'rss',
	'envelope',
	'tumblr',
	'flickr',
	'instagram',
	'pinterest',
	'youtube',
	'vimeo-square'
);

class Social_Widget extends WP_Widget {

	function Social_Widget() {
		$widget_ops = array( 'classname' => 'Social_Widget', 'description' => __('A widget that allows the user to display social media icons in their sidebar','satori' ) );
		$control_ops = array( 'width' => 850, 'height' => 350, 'id_base' => 'social-widget' );
		$this->WP_Widget( 'social-widget', __('Social Media Widget','satori' ), $widget_ops, $control_ops );
	}
	
	function widget( $args, $instance ) {
		
		extract( $args );
		
		global $socials;
		
		$new_socials = $socials;

		$title = apply_filters('widget_title', $instance['title'] );
		$text = apply_filters( 'widget_text', $instance['text'], $instance );
		
		foreach ( $new_socials as $new_social ) {
			$$new_social = $instance[$new_social];
		}
		
		$icon_size = $instance['icon_size'];
		$newtab = $instance['newtab'];
		$nofollow = $instance['nofollow'];
		$size = $instance['size'];
				
		if($icon_size == 'default') {
			$icon_size = '30';
		}
		
		if ($nofollow == 'on') {
			$nofollow = "rel=\"nofollow\"";
		} else {
			$nofollow = '';
		}
	
		if ($newtab == 'yes') {
			$newtab = "target=\"_blank\"";
		} else {
			$newtab = '';
		}
		
		if ($size == 'default') {
			$size = '14';
		}
				
		echo $before_widget;

		if ( $title ) {
			echo $before_title . $title . $after_title;
		}
		
		echo '<div class="socialmedia-buttons">';
		
		if ( $text ) {
			echo "<div class='socialmedia-text'>" . $text . '</div>';
		}
		
		foreach ( $new_socials as $index => $new_social ) {
			if ( $$new_social != '' && $$new_social != ' ' ) { ?>
            	<a href="<?php echo $$new_social; ?>" <?php echo $nofollow; echo $newtab; ?>>
                	<div class="social-widget-icon">
                		<i class="fa fa-<?php echo $socials[$index]; ?>"></i>
                	</div>
                </a>
            <?php
			} else {
				echo '';
			}
		}
						
		echo "</div>";
		echo $after_widget;
		echo '<style type="text/css">.social-widget-icon { width:'.$icon_size.'px; height:'.$icon_size.'px; line-height:'.$icon_size.'px; } .social-widget-icon i { line-height:'.$icon_size.'px; font-size:'.$size.'px; }</style>';
		
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		global $socials;
		$instance['title'] = strip_tags( $new_instance['title'] );
		if ( current_user_can('unfiltered_html') )
			$instance['text'] =  $new_instance['text'];
		else
		$instance['text'] = stripslashes( wp_filter_post_kses( addslashes($new_instance['text']) ) ); // wp_filter_post_kses() expects slashed
		$instance['icon_size'] = $new_instance['icon_size'];
		$instance['newtab'] = $new_instance['newtab'];
		$instance['nofollow'] = $new_instance['nofollow'];
		$instance['size'] = $new_instance['size'];
				
		foreach ( $socials as $social ) {
			$instance[$social] = strip_tags( $new_instance[$social] );
		}
						
		return $instance;
	}


	function form( $instance ) {
		
		global $socials;
		
		$defaults = array( 
			'title' => __('Follow Us!','satori' ),
			'text' => '',
			'icon_size' => 'default',
			'size' => 'default',
			'newtab' => 'yes',
			'nofollow' => 'on'
		);
		
		foreach ( $socials as $social ) {
			$defaults[$social] = '';
		}
		
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		<p>
		<em><?php echo __('Note: Make sure you include FULL URL (i.e. http://www.example.com)','satori'); ?></em><br />
		<?php echo __('If you do not want an icon to be visible, simply delete the supplied URL and leave the input blox blank.','satori'); ?>
		</p>
		
		<div style="width:32%; float: left; padding-right: 2%">
		<h3><?php echo __('General Settings','satori'); ?></h3>
		<!-- Widget Title: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:','satori' ); ?></label><br />
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" style="width:85%;" />
		</p>

		<!-- Widget Text: Textarea -->
		<p>
			<label for"<?php echo $this->get_field_id( 'text' ); ?>"><?php _e('Widget Text:','satori' ); ?></label>
			<textarea id="<?php echo $this->get_field_id('text'); ?>" name="<?php echo $this->get_field_name('text'); ?>" rows="8" cols="20" style="width:85%;" ><?php echo $instance['text']; ?></textarea>
		</p>
		
		<!-- Choose Box Size: Dropdown -->
	
		<p>
			<label for="<?php echo $this->get_field_id( 'icon_size' ); ?>"><?php _e('Icon Box Size','satori' ); ?></label>
			<select id="<?php echo $this->get_field_id( 'icon_size' ); ?>" name="<?php echo $this->get_field_name( 'icon_size' ); ?>">
            <option value="20" <?php if($instance['icon_size'] == '20') { echo 'selected'; } ?>>20px</option>
            <option value="25" <?php if($instance['icon_size'] == '25') { echo 'selected'; } ?>>25px</option>
			<option value="default" <?php if($instance['icon_size'] == 'default') { echo 'selected'; } ?>>Default (30px)</option>
			<option value="35" <?php if($instance['icon_size'] == '35') { echo 'selected'; } ?>>35px</option>
            <option value="40" <?php if($instance['icon_size'] == '40') { echo 'selected'; } ?>>40px</option>
            <option value="45" <?php if($instance['icon_size'] == '45') { echo 'selected'; } ?>>45px</option>
            <option value="50" <?php if($instance['icon_size'] == '50') { echo 'selected'; } ?>>50px</option>
			</select>
		</p>
        
        <!-- Choose Icon Size: Dropdown -->
		<p>
			<label for="<?php echo $this->get_field_id( 'size' ); ?>"><?php _e('Icon Size','satori' ); ?></label>
			<select id="<?php echo $this->get_field_id( 'size' ); ?>" name="<?php echo $this->get_field_name( 'size' ); ?>">
            <option value="10" <?php if($instance['size'] == '10') { echo 'selected'; } ?>>10px</option>
            <option value="12" <?php if($instance['size'] == '12') { echo 'selected'; } ?>>12px</option>
			<option value="default" <?php if($instance['size'] == 'default') { echo 'selected'; } ?>>Default (14px)</option>
			<option value="16" <?php if($instance['size'] == '16') { echo 'selected'; } ?>>16px</option>
            <option value="18" <?php if($instance['size'] == '18') { echo 'selected'; } ?>>18px</option>
            <option value="20" <?php if($instance['size'] == '20') { echo 'selected'; } ?>>20px</option>
            <option value="22" <?php if($instance['size'] == '22') { echo 'selected'; } ?>>22px</option>
			</select>
		</p>
	
		<!-- No Follow On or Off: Dropdown -->
		<p>
			<label for="<?php echo $this->get_field_id( 'nofollow' ); ?>"><?php _e('Use rel="nofollow" for links','satori' ); ?></label>
			<select id="<?php echo $this->get_field_id( 'nofollow' ); ?>" name="<?php echo $this->get_field_name( 'nofollow' ); ?>">
			<option value="on" <?php if($instance['nofollow'] == 'on') { echo 'selected'; } ?>>On</option>
			<option value="off" <?php if($instance['nofollow'] == 'off') { echo 'selected'; } ?>>Off</option>
			</select>
		</p>
		
		<!-- Open in new tab: Dropdown -->
		<p>
			<label for="<?php echo $this->get_field_id( 'newtab' ); ?>"><?php _e('Open in new tab?','satori' ); ?></label>
			<select id="<?php echo $this->get_field_id( 'newtab' ); ?>" name="<?php echo $this->get_field_name( 'newtab' ); ?>">
			<option value="yes" <?php if($instance['newtab'] == 'yes') { echo 'selected'; } ?>>Yes</option>
			<option value="no" <?php if($instance['newtab'] == 'no') { echo 'selected'; } ?>>No</option>
			</select>
		</p>
        
        </div>
        
        <div style="width:32%; float: left;">
		
		<h3><?php echo __('Social Networking','satori'); ?></h3>
		<!-- Facebook URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'facebook' ); ?>"><?php _e('Facebook URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'facebook' ); ?>" name="<?php echo $this->get_field_name( 'facebook' ); ?>" value="<?php echo $instance['facebook']; ?>" style="width:85%;" />
		</p>
		
		<!-- Google Plus URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'google-plus' ); ?>"><?php _e('Google+ URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'google-plus' ); ?>" name="<?php echo $this->get_field_name( 'google-plus' ); ?>" value="<?php echo $instance['google-plus']; ?>" style="width:85%;" />
		</p>
		
		<!-- Twitter URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'twitter' ); ?>"><?php _e('Twitter URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'twitter' ); ?>" name="<?php echo $this->get_field_name( 'twitter' ); ?>" value="<?php echo $instance['twitter']; ?>" style="width:85%;" />
		</p>

		<!-- LinkedIn URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'linkedin' ); ?>"><?php _e('LinkedIn URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'linkedin' ); ?>" name="<?php echo $this->get_field_name( 'linkedin' ); ?>" value="<?php echo $instance['linkedin']; ?>" style="width:85%;" />
		</p>
		
		<!-- Foursquare URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'foursquare' ); ?>"><?php _e('Foursquare URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'foursquare' ); ?>" name="<?php echo $this->get_field_name( 'foursquare' ); ?>" value="<?php echo $instance['foursquare']; ?>" style="width:85%;" />
		</p>
        
        <!-- Weibo URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'weibo' ); ?>"><?php _e('Weibo URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'weibo' ); ?>" name="<?php echo $this->get_field_name( 'weibo' ); ?>" value="<?php echo $instance['weibo']; ?>" style="width:85%;" />
		</p>
        
        <!-- RenRen URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'renren' ); ?>"><?php _e('RenRen URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'renren' ); ?>" name="<?php echo $this->get_field_name( 'renren' ); ?>" value="<?php echo $instance['renren']; ?>" style="width:85%;" />
		</p>
        
        <!-- vKontakte URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'vk' ); ?>"><?php _e('vKontakte URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'vk' ); ?>" name="<?php echo $this->get_field_name( 'vk' ); ?>" value="<?php echo $instance['vk']; ?>" style="width:85%;" />
		</p>
        
        <!-- Behance URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'behance' ); ?>"><?php _e('Behance URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'behance' ); ?>" name="<?php echo $this->get_field_name( 'behance' ); ?>" value="<?php echo $instance['behance']; ?>" style="width:85%;" />
		</p>
		
		</div>
		
        <div style="width:32%; float: left; padding-left: 10px; border-left: 1px solid #000">
	
		<h3><?php echo __('RSS & Email','satori'); ?></h3>
		
		<!-- RSS URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'rss' ); ?>"><?php _e('RSS URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'rss' ); ?>" name="<?php echo $this->get_field_name( 'rss' ); ?>" value="<?php echo $instance['rss']; ?>" style="width:85%;" />
		</p>
		
		<!-- Subscribe URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'envelope' ); ?>"><?php _e('E-mail URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'envelope' ); ?>" name="<?php echo $this->get_field_name( 'envelope' ); ?>" value="<?php echo $instance['envelope'] ?>" style="width:85%;" />
		</p>
		
		<h3><?php echo __('Blogging','satori'); ?></h3>
		<!-- Tumblr URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'tumblr' ); ?>"><?php _e('Tumblr URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'tumblr' ); ?>" name="<?php echo $this->get_field_name( 'tumblr' ); ?>" value="<?php echo $instance['tumblr']; ?>" style="width:85%;" />
		</p>
				
		<h3><?php echo __('Images and Video','satori'); ?></h3>
        
		<!-- Flickr URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'flickr' ); ?>"><?php _e('Flickr URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'flickr' ); ?>" name="<?php echo $this->get_field_name( 'flickr' ); ?>" value="<?php echo $instance['flickr']; ?>" style="width:85%;" />
		</p>
		
		<!-- Instagram URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'instagram' ); ?>"><?php _e('Instagram Web URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'instagram' ); ?>" name="<?php echo $this->get_field_name( 'instagram' ); ?>" value="<?php echo $instance['instagram']; ?>" style="width:85%;" />
		</p>
		
		<!-- Pinterest URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'pinterest' ); ?>"><?php _e('Pinterest URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'pinterest' ); ?>" name="<?php echo $this->get_field_name( 'pinterest' ); ?>" value="<?php echo $instance['pinterest']; ?>" style="width:85%;" />
		</p>
		
		<!-- YouTube URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'youtube' ); ?>"><?php _e('YouTube URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'youtube' ); ?>" name="<?php echo $this->get_field_name( 'youtube' ); ?>" value="<?php echo $instance['youtube']; ?>" style="width:85%;" />
		</p>
		
		<!-- Vimeo URL: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'vimeo-square' ); ?>"><?php _e('Vimeo URL:','satori' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'vimeo-square' ); ?>" name="<?php echo $this->get_field_name( 'vimeo-square' ); ?>" value="<?php echo $instance['vimeo-square']; ?>" style="width:85%;" />
		</p>
		
		</div>
		<div style="clear: both;"></div>
		
	<?php
	}
}

add_action('wp_head', 'Social_Widget_Scripts');
add_action( 'widgets_init', 'socialwidget_load_widgets' );

?>
